using System.Linq;
using Turbo.Plugins.Default;

namespace Turbo.Plugins.User
{

    public class MonsterDebuffs : BasePlugin
	{

        public WorldDecoratorCollection LDecorator { get; set; }        
		public WorldDecoratorCollection HDecorator { get; set; }
		public WorldDecoratorCollection LHDecorator { get; set; }
		
        public MonsterDebuffs()
		{
            Enabled = true;
		}

        public override void Load(IController hud)
        {
            base.Load(hud);

            LDecorator = new WorldDecoratorCollection(
                
                new GroundLabelDecorator(Hud)
                {
                    BackgroundBrush = Hud.Render.CreateBrush(255, 200, 50, 50, 0),
                    TextFont = Hud.Render.CreateFont("tahoma", 6.5f, 255, 255, 255, 255, false, false, false),
                }
            );
			
			HDecorator = new WorldDecoratorCollection(
                
                new GroundLabelDecorator(Hud)
                {
                    BackgroundBrush = Hud.Render.CreateBrush(255, 120, 0, 120, 0),
                    TextFont = Hud.Render.CreateFont("tahoma", 6.5f, 255, 255, 255, 255, false, false, false),
                }
            );
			
			LHDecorator = new WorldDecoratorCollection(
                
                new GroundLabelDecorator(Hud)
                {
                    BackgroundBrush = Hud.Render.CreateBrush(255, 40, 40, 240, 0),
                    TextFont = Hud.Render.CreateFont("tahoma", 6.5f, 255, 255, 255, 255, false, false, false),
                }
            );
        }

        public override void PaintWorld(WorldLayer layer)
        {
            var monsters = Hud.Game.AliveMonsters;
            foreach (var monster in monsters)
            {
                if (this.Hud.Game.Me.HeroClassDefinition.HeroClass == HeroClass.WitchDoctor)
				{
					if (monster.Locust && monster.Haunted) {
						LHDecorator.Paint(layer, monster, monster.FloorCoordinate, "OK");
					}
					else if (monster.Locust) {
						LDecorator.Paint(layer, monster, monster.FloorCoordinate, "L");
					}
					else if (monster.Haunted) {
						HDecorator.Paint(layer, monster, monster.FloorCoordinate, "H");
					}
					else {
						
					}
				}

                if (this.Hud.Game.Me.HeroClassDefinition.HeroClass == HeroClass.Wizard)
                {
                    if (monster.Stunned) {
                        LHDecorator.Paint(layer, monster, monster.FloorCoordinate, "STUNNED");
                    }
                }
            }
        }

    }

}